//----------------------------------------------------------------------//
// NyanFi																//
//  TurA[(GIFrA[)											//
//  Aj[VGIFΉAGIFȊO\								//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <algorithm>
#include <memory>
#include <Vcl.Imaging.GIFImg.hpp>
#include "usr_wic.h"
#include "Global.h"
#include "UserMdl.h"
#include "GifView.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGifViewer *GifViewer;

//---------------------------------------------------------------------------
__fastcall TGifViewer::TGifViewer(TComponent* Owner)
	: TForm(Owner)
{
	ImgLocked = false;
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormCreate(TObject *Sender)
{
	org_ImgPanelWndProc = ImgPanel->WindowProc;
	ImgPanel->WindowProc = ImgPanelWndProc;
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this);
	ImgPanel->Color = IniFile->ReadColGen(_T("GifViewBgCol"),	col_bgImage);
	Color = ImgPanel->Color;
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormHide(TObject *Sender)
{
	FileName  = EmptyStr;
	ImgLocked = false;
	Image1->Picture->Assign(NULL);

	IniFile->SavePosInfo(this);
	IniFile->WriteIntGen(_T("GifViewBgCol"),	(int)ImgPanel->Color);
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::WmSysCommand(TWMSysCommand &SysCom)
{
	//[~]{^ꂽ
	if (SysCom.CmdType==SC_CLOSE) {
		Close();
		if (ScrMode==SCMD_IVIEW) ShowGifViewer = false;
	}
	else TForm::Dispatch(&SysCom);
}
//---------------------------------------------------------------------
void __fastcall TGifViewer::WmExitSizeMove(TMessage &msg)
{
	Application->MainForm->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormResize(TObject *Sender)
{
	if (FileName.IsEmpty()) return;
	if (Image1->Picture->Width==0 || Image1->Picture->Height==0) return;

	Image1->Align		 = alClient;
	Image1->Center		 = true;
	Image1->Proportional = true;
}

//---------------------------------------------------------------------------
//bN؂ւ̃pl̂h~
//---------------------------------------------------------------------------
void __fastcall TGifViewer::ImgPanelWndProc(TMessage &msg)
{
	if (msg.Msg==WM_ERASEBKGND) { msg.Result = 1; return; }

	org_ImgPanelWndProc(msg);
}

//---------------------------------------------------------------------------
//摜̕`
//---------------------------------------------------------------------------
void __fastcall TGifViewer::DrawImage(UnicodeString fnam)
{
	if (ImgLocked) return;

	try {
		if (!file_exists(fnam)) Abort();

		UnicodeString ex_str;
		UnicodeString fext = ExtractFileExt(fnam);
		if (test_GifExt(fext)) {
			std::unique_ptr<TGIFImage> gif_buf(new TGIFImage());
			gif_buf->LoadFromFile(fnam);
			gif_buf->Animate	 = true;
			gif_buf->Transparent = true;
			if (ex_str.IsEmpty()) ex_str = get_wd_x_hi_str(gif_buf->Width, gif_buf->Height);
			Image1->Picture->Assign(gif_buf.get());
			Image1->Transparent = true;
			Image1->Visible 	= true;
		}
		else if (test_MetaExt(fext)) {
			std::unique_ptr<TMetafile> meta_buf(new TMetafile());
			meta_buf->LoadFromFile(fnam);
			Image1->Picture->Assign(meta_buf.get());
			Image1->Transparent = true;
			Image1->Visible 	= true;
		}
		else if (test_FileExt(fext, FEXT_META FEXT_WICSTD + WicFextStr) || SPI->TestFExt(fext)) {
			std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
			int res = load_ImageFile(fnam, bmp.get(), WICIMG_PREVIEW, ImgPanel->Color);
			if (res==0) Abort();

			if (test_ExifExt(fext)) {
				int ori = 0;
				ex_str	= get_ExifInfStr(fnam, &ori);
				//]
				int rot = (ori==6)? 1 : (ori==8)? 3 : 0;
				if (RotViewImg && rot>0 && res!=LOADED_BY_WIC) WIC_rotate_image(bmp.get(), rot);
			}
			else if (test_PngExt(fext))
				ex_str = get_PngInfStr(fnam);
			else if (USAME_TI(fext, ".webp"))
				ex_str = get_WebpInfStr(ViewFileName);

			if (ex_str.IsEmpty()) ex_str = get_wd_x_hi_str(bmp->Width, bmp->Height);

			Image1->Picture->Assign(bmp.get());
			Image1->Transparent = false;
			Image1->Visible 	= true;
		}
		else Abort();

		FileName = fnam;
		FormResize(NULL);
		Caption = UnicodeString().sprintf(_T("%s  %s"), ExtractFileName(FileName).c_str(), ex_str.c_str());
	}
	catch (...) {
		Image1->Visible = false;
		FileName = EmptyStr;
		Caption  = "none";
	}
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::SetImgLocked(bool Value)
{
	FImgLocked = Value;

	if (FImgLocked) {
		Color = clRed;
		BorderWidth = 1;
	}
	else {
		BorderWidth = 0;
		Color = ImgPanel->Color;
	}
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::Image1Click(TObject *Sender)
{
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormClick(TObject *Sender)
{
	Application->MainForm->SetFocus();
}

//---------------------------------------------------------------------------
//|bvAbvj[
//---------------------------------------------------------------------------
void __fastcall TGifViewer::PopupMenu1Popup(TObject *Sender)
{
	LockItem->Checked = ImgLocked;
}
//---------------------------------------------------------------------------
//wiFݒ
//---------------------------------------------------------------------------
void __fastcall TGifViewer::BgColItemClick(TObject *Sender)
{
	UserModule->ColorDlg->Color = Color;
	if (UserModule->ColorDlg->Execute()) {
		ImgPanel->Color = UserModule->ColorDlg->Color;
		if (!ImgLocked) Color = ImgPanel->Color;

		DrawImage(FileName);
	}
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::LockItemClick(TObject *Sender)
{
	ImgLocked = !ImgLocked;
	Repaint();
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------

