//----------------------------------------------------------------------//
// NyanFi																//
//  [y																//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "usr_wic.h"
#include "Global.h"
#include "MainFrm.h"
#include "LoupeFrm.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLoupeForm *LoupeForm;

//---------------------------------------------------------------------------
__fastcall TLoupeForm::TLoupeForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TLoupeForm::FormShow(TObject *Sender)
{
	if (Floating) IniFile->LoadPosInfo(this, 50, 100, 200, 200);

	DragKind = NyanFiForm->ImgSidePanel->Visible? dkDock : dkDrag;
	DragMode = NyanFiForm->ImgSidePanel->Visible? dmAutomatic : dmManual;

	int n = IniFile->ReadIntGen(_T("LoupeMag"),	1);
	for (int i=0; i<MagToolBar->ButtonCount; i++)
		MagToolBar->Buttons[i]->Down = (MagToolBar->Buttons[i]->Tag==n);
}

//---------------------------------------------------------------------------
void __fastcall TLoupeForm::FormHide(TObject *Sender)
{
	if (Floating) IniFile->SavePosInfo(this);
	SaveOption();

	if (!Floating) ShowLoupe = false;
}

//---------------------------------------------------------------------------
void __fastcall TLoupeForm::SaveOption()
{
	IniFile->WriteBoolGen(_T("LoupeFloating"), Floating);

	int n = 1;
	for (int i=0; i<MagToolBar->ButtonCount; i++)
		if (MagToolBar->Buttons[i]->Down) n = MagToolBar->Buttons[i]->Tag;
	IniFile->WriteIntGen(_T("LoupeMag"),	n);

	if (!Floating) {
		TPanel *pp = NyanFiForm->LoupeDockPanel;
		IniFile->WriteIntGen(_T("LoupeHeight"),	pp->Height);
		pp->Constraints->MinHeight = 1;
		pp->Constraints->MaxHeight = 1;
		NyanFiForm->SideDockPanel->Height = NyanFiForm->HistDockPanel->Height;
		NyanFiForm->SideDockSplitter->Height = 0;
	}
}

//---------------------------------------------------------------------------
void __fastcall TLoupeForm::WmSysCommand(TWMSysCommand &SysCom)
{
	//[~]{^ꂽ
	if (SysCom.CmdType==SC_CLOSE) {
		Close();
		ShowLoupe = false;
	}
	else TForm::Dispatch(&SysCom);
}
//---------------------------------------------------------------------------
void __fastcall TLoupeForm::ToolBtnClick(TObject *Sender)
{
	DrawImage();
	Application->MainForm->SetFocus();
}

//---------------------------------------------------------------------------
//`
//---------------------------------------------------------------------------
void __fastcall TLoupeForm::DrawImage(Graphics::TBitmap *bmp, int x, int y)
{
	if (!ImgViewThread) return;

	if (bmp) {
		int n = 1;
		for (int i=0; i<MagToolBar->ButtonCount; i++)
			if (MagToolBar->Buttons[i]->Down) n = MagToolBar->Buttons[i]->Tag;
		int vw = LoupeImage->Width / n;
		int vh = LoupeImage->Height/ n;
		TRect irc = Rect(x - vw/2, y - vh/2, x + vw/2, y + vh/2);

		std::unique_ptr<Graphics::TBitmap> tmp_bmp(new Graphics::TBitmap());
		tmp_bmp->SetSize(LoupeImage->Width, LoupeImage->Height);
		tmp_bmp->Canvas->Brush->Color = col_bgImage;
		tmp_bmp->Canvas->FillRect(LoupeImage->ClientRect);
		tmp_bmp->Canvas->CopyRect(LoupeImage->ClientRect, bmp->Canvas, irc);
		if (ImgViewThread->GrayScaled) WIC_grayscale_image(tmp_bmp.get());
		LoupeImage->Picture->Bitmap->Assign(tmp_bmp.get());
	}
	else
		LoupeImage->Picture->Bitmap->Handle = NULL;
}

//---------------------------------------------------------------------------
//˂\
//---------------------------------------------------------------------------
void __fastcall TLoupeForm::LoupeImageMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
	NyanFiForm->UpdateLoupe();
}
//---------------------------------------------------------------------------
void __fastcall TLoupeForm::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------

